<template>
<b-row>
  <b-col>
    <img
      v-if="layer.ThumbnailUrl!=undefined"
      :src="layer.ThumbnailUrl"
      class="image-item"
    />
    <span
      class="result-element"
      @click="selectLayer(layer)"
      :title="layer.Title">{{ layer.Title }} {{ layer.status }}
    </span>
    <span class="result-element">
      &nbsp;<b-icon icon="info-square" v-if="layer.Abstract && layer.Abstract != ''"
      v-bind:title="layer.Abstract"></b-icon>
      &nbsp;<b-icon icon="diagram3" v-if="layerGroup" title="Groupe de couches"></b-icon>

      &nbsp;<b-icon icon="brush" v-if="hasMultipleStyle"
      title="Plusieurs styles disponibles"></b-icon>

      &nbsp;<b-icon icon="caret-right" v-if="hasSubLayers && showSubLayers" @click="toggle()"
      title="Catégorie de couches"></b-icon>
      <b-icon icon="caret-down" v-if="hasSubLayers && !showSubLayers" @click="toggle()"
      title="Catégorie de couches"></b-icon>

    </span>
    <div class="subresults" v-if="hasSubLayers && showSubLayers">
      <div v-for="result of layer.Layer"
      :key="result.id" class="resultItem" :class="{ 'selected': isSelected(result)}">
        <OgcLayerResult v-bind:layer="result"
          v-bind:layerType="layerType"
          v-bind:selectedLayerList="selectedLayerList"
          v-bind:selectedStyle="selectedStyle"
          v-on:selectLayer="selectLayer($event)"
        />
      </div>
    </div>
  </b-col>
</b-row>
</template>

<script lang="ts">
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
/* eslint-disable @typescript-eslint/no-explicit-any */
import { OGCLayer } from '@/models/RemoteServer';
import Component from 'vue-class-component';
import BaseComponent from '../../BaseComponent';

@Component({
  name: 'OgcLayerResult',
  props: {
    layer: {},
    layerType: String,
    selectedLayerList: {},
    selectedStyle: {},
  },
})
export default class OgcLayerResult extends BaseComponent {
  layer!:any;

  layerType!:string;

  selectedLayerList !:any;

  selectedStyle !:any;

  layerGroup = false;

  hasMultipleStyle = false;

  showSubLayers = true;

  toggle() :void {
    this.showSubLayers = !this.showSubLayers;
  }

  isSelected(result:OGCLayer): boolean {
    if (this.selectedLayerList.length === 0) {
      return false;
    }
    return this.selectedLayerList.find((x:OGCLayer) => x.Title === result.Title) !== undefined;
  }

  mounted() {
    console.log(this.layer);
    if (this.layer.Style === undefined && this.layer.Layer === undefined) {
      this.layerGroup = true;
    }
    if (this.layer.Style !== undefined && this.layer.Style.length > 1) {
      this.hasMultipleStyle = true;
    }
  }

  public get hasSubLayers():boolean {
    if (this.layer.Layer !== undefined && this.layer.Layer.length > 0) {
      return true;
    }
    return false;
  }

  selectLayer(layer:any) :void{
    console.log(this.layer);
    this.$emit('selectLayer', layer);
  }
}

</script>

<style scoped lang="less">
@import "../../../styles/variables.less";

.subresults{
  padding-left: 25px;
}
.resultItem{
  border-radius: 2px;
  box-shadow: 0 1px 3px rgba(0,0,0,0.12), 0 1px 2px rgba(0,0,0,0.24);
  margin:15px;
  padding:10px;
  cursor:pointer;
}
.resultItem:nth-child(even){
    background-color: rgba(130, 33, 115, 0.1);
}

.resultItem.selected{
    background-color: @first;
    color:white;
}
.result-element {
  overflow: hidden;
  text-overflow: ellipsis;
  max-width: 100%;
  display: inline-block;
}

.image-item {
    height: 60px;
    width: 83px;
    -o-object-fit: cover;
    object-fit: cover;
    border: 1px solid #b4b4b4;
    border-radius: 4px;
  }
</style>
